var cmlg__main_js = {

	deleteCookie: function(name) {
        document.cookie = name + '=; expires=Thu, 01 Jan 1970 00:00:00 UTC; path=/;';
	},

	openLangDd: function(){
		const ea = document.querySelectorAll('.cmlg_lsul_dd');
		
		ea.forEach( e => {
			//const e = document.querySelector('#cmlg_lsul_dd');
			var computedStyle = window.getComputedStyle( e );
			var isVisible = computedStyle.display !== 'none' && computedStyle.visibility !== 'hidden';
			
			if ( isVisible ){
				e.style.display = 'none';
			}else{
				e.style.display = 'flex';
			}
		});
	},
	
	correctSiteLinks: function(){
		//console.log( 'cSL' );
		if ( cmlg__lang == "" ) return;

		const u 	= cmlg__mainUrlSlash;
		const uLang = cmlg__mainUrlSlash + cmlg__lang + '/';

		const anchors = document.querySelectorAll('a');
		anchors.forEach(function(anchor) {
			//console.log( anchor, anchor.href );
			
			if ( anchor.getAttribute('cmlg_is_lang_switch') === '1' ) return;

			if ( anchor.href.startsWith( u ) ){
				if ( ! anchor.href.startsWith( uLang ) ){
					anchor.href = anchor.href.replace( u, uLang );
				}
			}
		});

		setTimeout( this.correctSiteLinks, 2000 );
	},


	delCookieOnLangChg: function(){
		const self = this;
		document.querySelectorAll(".cmlg_lang_chgr").forEach( e => {
			e.addEventListener("mousedown", function(){
				self.deleteCookie("cmlg_clg");
			});
		});
	},
	
	correctFormsAction: function(){
		//alert( 'here' + cmlg__lang );
		if ( !cmlg__lang ) return;

		const forms = document.getElementsByTagName('form');

		for (let i = 0; i < forms.length; i++) {
			const form = forms[i];

			const origin = window.location.origin;

			let newAction = form.action.replace( origin + '/' + cmlg__lang + '/', origin + '/' );			
			newAction = newAction.replace( origin + '/', origin + '/' + cmlg__lang + '/' );
			
			if ( form.method.toLowerCase() === 'get' ) {
				form.action = newAction;
			}
		}
	
	},
	
	toggleAutoTransDiv: function(){
		const e = document.querySelector('#cmlg_trans_widget_auto');
		if ( !e ) return;
		
		e.addEventListener('click', function(event){
			const eSel  = document.querySelector('#cmlg_trans_widget_auto_lang_selected');
			const eList = document.querySelector('#cmlg_trans_widget_auto_langlist');
			if ( ! eSel || ! eList ) return;

			//console.log( 'clicked', eList.style.display, '!' )
			
			if ( eList.style.display == 'none' || eList.style.display == '' ){
				//show it
				eList.style.display = 'block';
				eSel.style.display  = 'none';
			}else{
				eList.style.display = 'none';
				eSel.style.display  = 'block';
			}

		});
	},
	
}



document.addEventListener("DOMContentLoaded", function(event) {
	cmlg__main_js.toggleAutoTransDiv();

	let lg = '';
	try{ 
		lg == cmlg__lang 
	}catch(e){
		return;
	}
	if ( ! cmlg__lang ) return; //if it is cmlg_oc = 100 then return;

	cmlg__main_js.correctSiteLinks();
	cmlg__main_js.delCookieOnLangChg();
	
	cmlg__main_js.correctFormsAction();	
});