var cmlg__mlgp_be = function(){	
	var waitTime = 500;
	
	var transRmgCounter = 0;
	var transRmgCounterMax = 3;
	var transFailedCounter = 0;
	
	var lang = '';
	var link = '';
	var postId = 0;
	var timeStart = 0;
	
	var cmlg_globe_tsst = null;
	var langs_arr = [];
	var source_html = '';
	
	function checkForDone(){		
		const allParagraphs = document.querySelectorAll('#cmlg_ex_t2 p');
		const rmg = [...allParagraphs].filter(paragraph => !paragraph.querySelector('font'));

		console.log( 'Checking if done:', lang, link, 'rmg:', rmg.length, 'fc:', transRmgCounter );

		if ( rmg.length === 0 || transRmgCounter > transRmgCounterMax ){
			
			if ( rmg.length > 0 && transRmgCounter > transRmgCounterMax ){
				transFailedCounter++;
			}
			
			sendToParent();
			return;
		}else{
			transRmgCounter++;
		}

		//gtElInit();
		mimicFocus();
		setTimeout( checkForDone, waitTime);
	}

	function timeEnd( start ){
		const t = parseInt( ( Date.now() - start )) + '(ms)';
		return t;
	}

	function sendTranslatedContent( lang, pageUrl, strTranslated, postId ){
		//fire ajax post to send translated text.
		const u = cmlg_globe_tsst.siteUrlSlash + '?__' + Date.now();
		
		var formData = new FormData();
		
		formData.append('cmlg_opcode', '100');
		formData.append('cmlg_lang', lang);
		formData.append('cmlg_page_url', pageUrl);
		formData.append('cmlg_lang_url', '/' + lang + pageUrl);
		formData.append('cmlg_page_html', strTranslated);
		formData.append('cmlg_nonce', cmlg_globe_tsst.nonce);
		formData.append('cmlg_postId', postId);

		const timeStartSave = Date.now();
		
		
		//alert ( 'sendTranslatedContent: before send: ' + lang +', ' + pageUrl + ', ' + strTranslated );

		//
		fetch( u, {
			method: 'POST',
			body: formData,
		})
		.then(response => response.text())
		.then(data => {
			
			transNextLang();
			console.log('Success:', timeEnd( timeStartSave ), data, cmlg_globe_tsst.siteUrlSlash + lang + pageUrl );
		})
		.catch(error => {
			console.error('Error:', error);
		});

	}
	
	function transNextLang(){
		if ( langs_arr.length <= 0 ) return;

		document.getElementById('cmlg_ex_t2').innerHTML = '';

		lang = langs_arr.pop();
		console.log( "transNextLang: Going to do the extra lang: ", lang, link, postId );
		
		const hInfo = '<div>/' + lang + link + '</div>'; 
		window.parent.o_cmlg__trans_setup.showInfo( link, hInfo );
		
		//alert( "click ok to start : " + lang + ' : ' + link );
		//call from inside for other langs so langs_str is not sent.
		kickOffTrans( cmlg_globe_tsst, lang, link, source_html, postId, '', true ); 		
	}
	
	function sendToParent(){
		console.log( 'sendToParent:', lang, link, timeEnd( timeStart ) );

		const t2 = document.getElementById('cmlg_ex_t2');
		t2.style.display="none";
		removeFontTags();
		let html_trans = t2.innerHTML.trim();

		if ( transFailedCounter > 0 ){
			html_trans = document.getElementById('cmlg_ex_t2').outerHTML;
		}else{
			sendTranslatedContent( lang, link, html_trans, postId );
		}
		
		if ( langs_arr.length > 0 ){
			return;
			
		}else{ //other langs also done
			window.parent.o_cmlg__trans_setup.callBackTransDone( transFailedCounter, lang, link, html_trans, postId );
		}
	}

	function kickOffTrans( obj, lg, lk, html, id, langs_str, isOtherLangs = false ){
		if ( langs_str ) {
			langs_arr = langs_str.split(',');
		}
		
		timeStart = Date.now();
		//console.log( 'kickOffTrans: id:', id, 'lg:',lg,'lk:',lk,'html:',html.substr(0, 255) );
		console.log( 'kickOffTrans:', id, lg, lk );

		const ext2 = document.getElementById('cmlg_ex_t2');
		ext2.innerHTML = '';

		var lib = google.translate.TranslateService();lib.translatePage( cmlg__lang50defa, lg, function () {});
		
		if ( isOtherLangs ){
			//
		}else{
			source_html = html;
		}

		transRmgCounter = 0;	transFailedCounter = 0;
		lang = ''; link = ''; postId = 0;
		cmlg_globe_tsst = obj;
		
		if ( ! ext2 ) {
			console.log( 't2 div not found', ext2 );
			setTimeout( function(){
				//kickOffTrans( lg, lk, html, id );
			},20000);
			return;
		}
		
		//mimicFocus();
		ext2.outerHTML = html;
		//mimicFocus();
		//gtElInit();
		//mimicFocus();

		lang 	= lg;
		link 	= lk;
		postId 	= id;

		setTimeout( function(){
			checkForDone();
		},waitTime)	
	}
	
	function mimicFocus(){
		window.dispatchEvent(new Event('focus'));

		var visibilityChangeEvent = new Event('visibilitychange', { bubbles: true });
		Object.defineProperty(visibilityChangeEvent, 'target', { value: document, enumerable: true });

		document.dispatchEvent(visibilityChangeEvent);
	}
	
	window.addEventListener("load", function(event) {
		
	});

	function removeFontTags(){
		const allPs = document.querySelectorAll('#cmlg_ex_t2 p.cmlg_tpdtl');
		allPs.forEach( p => {
			p.innerHTML = p.innerText;
		});
	}

	return {
		kickOffTrans: kickOffTrans
	}
}

//--- o_cmlg__mlgp_be = new cmlg__mlgp_be();
