var cmlg__transMenu = {
	srcUrl:'',
	transUrl:'',
	extraTransElements:[],
	langsToTranslate:[],
	oneLangTrans: '',
	lastLang:'',
	waitNext: 10,
	timeStart: 0,
	
	openTranslateIframe: function( url, lang ){
		this.srcUrl = url;
		this.oneLangTrans = lang;
		this.timeStart = Date.now();

		let langsArray = [ lang ];
		if ( lang == '@@' ){
			langsArray = cmlg__allLangs;
			this.waitNext = 10;
			
		} else if (  lang == '##' ){
			langsArray = cmlg__rmgLangs;
			this.waitNext = 10;
		}
		
		console.log( 'langsArray', langsArray );
		this.langsToTranslate = langsArray;
		
		this.transNextLang( 0, true );
	},
	
	reloadMe: function(){
		window.location = window.location;
		window.location.reload();
	},
	
	transNextLang: function( transFailedCounter, isFirst = false ){
		const tillNow = parseInt( Date.now() - this.timeStart );
		console.log( 'Time Taken till now:', tillNow, '(ms)' );
		
		if ( transFailedCounter > 0 ){
			//alert( 'The translation has been failed for: ' + this.lastLang + '\n Err Count: ' + transFailedCounter + '\n Click OK to reload and try the remaining languages again.');
			if ( this.timeStart > 0 ) this.reloadMe();

			return;
		}
		
		console.log( 'tmu: rmg langs', this.langsToTranslate );
		
		if ( this.langsToTranslate.length <= 0 ) {
			//if all or remaining langs are translated then reload the english page.
			if ( this.oneLangTrans == '@@' || this.oneLangTrans == '##' ){
				this.reloadMe();

			} else {
				if ( this.timeStart > 0 ) window.location.href = this.transUrl; //load last lang url if one lang is translated.
			}
			return;
		}

		let lg = this.langsToTranslate.shift();
		this.lastLang = lg;

		//replace @@ and ##
		console.log( 'transNextLang: this.srcUrl:', this.srcUrl );
		//x const url = this.srcUrl.replaceAll( '%3D%40%40', '='+lg ).replaceAll( '%3D%23%23', '='+lg );
		const url = this.srcUrl.replaceAll( '&cmlang=##', '&cmlang='+lg ).replaceAll( '&cmlang=@@', '&cmlang='+lg );

		const tmpu = cmlg__mainUrl + cmlg__pageUrl;
		this.transUrl = tmpu.replace( cmlg__mainUrl, cmlg__mainUrl + '/' + lg  );
		
		//alert( 'Click OK to translate next lang: ' + lg );
		
		//window.location.href = url;

		let wN = this.waitNext;
		if ( isFirst ) wN = 10;

		setTimeout( () => {
			console.log( this.transUrl, lg, '!', this.srcUrl, 'url:', url );
			this.createIframe( url );
			
		}, wN );

		//this.openTransPop( url, lg );		
	},

	createIframe: function ( src ) {
		setTimeout(() => this.moveDown(), 500);
		
		const tmp = document.getElementById('cmlg-ifm-t'); 
		if ( tmp ) {
			tmp.src = src;
			return;
		}
		
		// let s = document.body.style;
		// s.opacity = 0.4;
		// s.cursor = 'wait';
		// s.pointerEvents = 'none';
		
		this.showLoadingOverlay();
		
		console.log( 'ifram url=', src );
		var iframe = document.createElement('iframe');

		iframe.id = "cmlg-ifm-t";
		iframe.src = src;
		iframe.frameBorder = '0';

		iframe.style.width = '100%';
		iframe.style.height = document.body.offsetHeight  + 'px';
		//iframe.style.overflow = 'scroll';
		iframe.style.opacity = '0';
		iframe.style.position = 'absolute';
		//iframe.style.zIndex = '-99999';

		iframe.style.top = '0px';
		//iframe.style.left = '-10000px';

		document.body.appendChild(iframe);
	},
	
	moveDown: function() {
		window.scrollBy(0, 400);
		
		if ( window.scrollY >= window.scrollMaxY ){
			window.scrollTo(0,0);
		}else{
			setTimeout(() => this.moveDown(), 500);
		}
	},
  
	showLoadingOverlay: function() {
		//if ( document.getElementById('cmlg_ov_inproc') ) return; //already created overlay
		
		document.body.style.pointerEvents = 'none';
		
		// Create overlay		
		var overlay = document.createElement('div');
		
		overlay.id = 'cmlg_ov_inproc';
		overlay.style.position = 'fixed';
		overlay.style.top = '0';
		overlay.style.left = '0';
		overlay.style.width = '100%';
		overlay.style.height = '100%';
		
		overlay.style.background = 'rgba(169, 169, 169, 0.7)'; // Light grey color		
		
		//overlay.style.cursor = 'wait';
		overlay.style.display = 'flex';
		overlay.style.alignItems = 'center';
		overlay.style.justifyContent = 'center';
		overlay.style.zIndex = '99999999';

		// Create spinner
		var spinner = document.createElement('div');
		spinner.style.border = '4px solid rgba(0, 0, 0, 0.3)';
		spinner.style.borderRadius = '50%';
		spinner.style.borderTop = '4px solid #3498db';
		spinner.style.width = '40px';
		spinner.style.height = '40px';
		spinner.style.animation = 'spin 1s linear infinite';
		
		// Define animation
		var animation = document.createElement('style');
		animation.type = 'text/css';
		animation.innerHTML = '@keyframes spin { 0% { transform: rotate(0deg); } 100% { transform: rotate(360deg); } }';
		document.head.appendChild(animation);

		// Apply animation to spinner
		spinner.style.animation = 'spin 1s linear infinite';

		// Append spinner to overlay
		overlay.appendChild(spinner);

		// Append overlay to body
		document.body.appendChild(overlay);
	},

	openTransPop: function ( src, lang ) {
		var widthScreen = window.screen.width;
		//widthScreen = 50;
		//,top=-100,left=-2000
		var popupWindow = window.open(src, '_blank', 'width=' + widthScreen + ',height=50,location=no,toolbar=no');
		popupWindow.blur(); window.focus();

		if (popupWindow) {
			popupWindow.document.title = 'Translating to ' + lang;

		} else {
			alert('Please allow popups from this site. This is required to start the translation process.');
		}
		
		let tU = this.transUrl;
		setTimeout(redirectOnTransDone, 1000);

		function redirectOnTransDone() {			
            if (popupWindow) {
				//alert( tU );
				if (popupWindow.closed){
					window.location.href = tU;
				}else{
					console.log( 'try to focus back' );
					//popupWindow.blur(); 
					window.focus();
					setTimeout(redirectOnTransDone, 1000);
				}
            }else{
				setTimeout(redirectOnTransDone, 1000);
			}
        }
	},

    __e: function(selector) {
        return document.querySelector(selector);
    },
    __ea: function(selector) {
        return document.querySelectorAll(selector);
    }
};